﻿unit ECoN21;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Grids, Vcl.StdCtrls, Vcl.ExtCtrls,Math,
  MainCalc,CalcExpress,ECoNAbout,Bonds,CommDlg, Vcl.Menus, CommCtrl,Poly, Results;

type
  THoppe = class(TForm)
    FileOpenDialog1: TFileOpenDialog;
    CE: TCalcExpress;
    Panel3: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel1: TPanel;
    Panel8: TPanel;
    Panel10: TPanel;
    SG1: TStringGrid;
    OpenFileButton: TButton;
    CalculateButton: TButton;
    values: TMemo;
    variables: TMemo;
    Atoms: TLabel;
    QuitButton: TButton;
    AboutButton: TButton;
    FileNamePanel: TPanel;
    SG2: TStringGrid;
    Panel11: TPanel;
    Panel9: TPanel;
    Memo1: TMemo;
    SectionCombo: TComboBox;
    SectionComboLabel: TLabel;
    ShowXCenteredButton: TButton;
    SaveAsButton: TButton;
    AutosaveCheck: TCheckBox;
    Label2: TLabel;
    ChMemo: TMemo;
    BondsButton: TButton;
    aPanel: TPanel;
    bPanel: TPanel;
    cPanel: TPanel;
    alphaPanel: TPanel;
    betaPanel: TPanel;
    gammaPanel: TPanel;
    SpaceGroupPanel: TPanel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    aLabel: TLabel;
    bLabel: TLabel;
    cLabel: TLabel;
    alphaLabel: TLabel;
    betaLabel: TLabel;
    gammaLabel: TLabel;
    SaveDialog1: TSaveDialog;
    PolGeomButton: TButton;
    CifTime: TLabel;
    DetailedResults: TCheckBox;
    OmitCheckBox: TCheckBox;

    procedure FormShow(Sender: TObject);
    procedure OpenCifFile(Sender: TObject);
    procedure SectionCom(Sender: TObject);
    procedure NoniterativeClick(Sender: TObject);
    procedure QuitButtonClick(Sender: TObject);
    procedure AboutButtonClick(Sender: TObject);
    procedure SG2DblClick(Sender: TObject);
    procedure SectionComboSelect(Sender: TObject);
    procedure MaxRadiusChange(Sender: TObject);
    procedure ShowXCenteredButtonClick(Sender: TObject);
    procedure OmitCheckBoxClick(Sender: TObject);
    procedure CalculateButtonClick(Sender: TObject);
    procedure ChardiIterationClick(Sender: TObject);
    procedure OneStepClick(Sender: TObject);
    procedure BondsButtonClick(Sender: TObject);
    procedure SG2DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
              State: TGridDrawState);
    procedure SaveAsButtonClick(Sender: TObject);
    procedure Bonds1Click(Sender: TObject);
    procedure AutosaveCheckClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }

  end;

 var
 Hoppe: THoppe;
 SymOpArray:TStringList;

 CLine:integer;

implementation

{$R *.dfm}

function GetTextWidth(AText: String; AFont: TFont): Integer;
var
  bmp: TBitmap;
begin
  Result := 0;
  bmp := TBitmap.Create;
  try
    bmp.Canvas.Font.Assign(AFont);
    Result := bmp.Canvas.TextWidth(AText);
  finally
    bmp.Free;
  end;
end;

procedure LoadRecords;
var
i,j,ai:integer;
PrevSep:string;

begin
  if ACLength<>0 then AtomRecordClear;
  with Hoppe do
  begin
    //load records with SG1.Cells content
    //firstly, cations
    for i := 1 to ACLength do
    if Pos('-',SG1.Cells[3,i])=0 then
      with AC[i] do
          begin
            Atomlabel:=SG1.Cells[1,i];
            Symbol:=SG1.Cells[2,i];
            PrevSep:=GetCharge(Sg1.Cells[3,i],Sgn,Charge);
            PrevSep:=Charge;
            Val(PrevSep,effcharge,j);
            RoString:=SG1.Cells[9,i];
            SymOp:='x,y,z';
            Val(SG1.Cells[4,i],multiplicity,j);
            Val(SG1.Cells[5,i],X,j);
            Val(SG1.Cells[6,i],Y,j);
            Val(SG1.Cells[7,i],Z,j);
            Val(SG1.Cells[8,i],occupancy,j);
            AtomSymbol:=OrderSymbols(SG1.Cells[11,i],'-');
            SG1.Cells[11,i]:= AtomSymbol;
            //orthogonal coordinates
            CX:=X*TM[1,1]+Y*TM[1,2]+Z*TM[1,3];
            CY:=X*TM[2,1]+Y*TM[2,2]+Z*TM[2,3];
            CZ:=X*TM[3,1]+Y*TM[3,2]+Z*TM[3,3];
          end;
         //secondly, anions
         for i := 1 to AAlength do
           if Pos('-',SG1.Cells[3,i+ACLength])<>0 then
             with AA[i] do
               begin
                 ai:=i+AClength;
                 Atomlabel:=SG1.Cells[1,ai];
                 Symbol:=SG1.Cells[2,ai];
                 PrevSep:=GetCharge(Sg1.Cells[3,ai],Sgn,Charge);
                 PrevSep:=Sgn+Charge;
                 Val(PrevSep,effcharge,j);
                 RoString:=SG1.cells[9,ai];
                 SymOp:='x,y,z';
                 Val(SG1.Cells[4,ai],multiplicity,j);
                 Val(SG1.Cells[5,ai],X,j);
                 Val(SG1.Cells[6,ai],Y,j);
                 Val(SG1.Cells[7,ai],Z,j);
                 Val(SG1.Cells[8,ai],occupancy,j);
                 AtomSymbol:=OrderSymbols(SG1.Cells[11,ai],'-');
                 SG1.Cells[11,ai]:=AtomSymbol;
                 //orthogonal coordinates
                 CX:=X*TM[1,1]+Y*TM[1,2]+Z*TM[1,3];
                 CY:=X*TM[2,1]+Y*TM[2,2]+Z*TM[2,3];
                 CZ:=X*TM[3,1]+Y*TM[3,2]+Z*TM[3,3];
               end;
  end;
end;

procedure LoadGeneratedRecords;
var
  i,ai,ci,nongen:integer;
  PrevSep:string;

begin
  nongen:=AALength+ACLength ;
  with Hoppe do
  begin
  //cations first
  for i := 1 to GACLength do
    begin
      ai:=i+ACLength;ci:=i+nongen;
      if pos('-',SG1.Cells[3,ci])=0 then
        begin
          AC[ai].Atomlabel:=SG1.Cells[1,ci];
          AC[ai].Symbol:=SG1.Cells[2,ci];
          AC[ai].AtomSymbol:=SG1.Cells[11,ci];
          AC[ai].multiplicity:=StrToInt(SG1.Cells[4,ci]);
          PrevSep:=SG1.Cells[3,ci];
          AC[ai].effcharge:=xStrToFloat(PrevSep);;
          AC[ai].SymOp:=SG1.Cells[10,ci];
          AC[ai].RoString:=SG1.Cells[9,ci];
          AC[ai].X:=xStrToFloat(SG1.Cells[5,ci]);
          AC[ai].Y:=xStrToFloat(SG1.Cells[6,ci]);
          AC[ai].Z:=xStrToFloat(SG1.Cells[7,ci]);
          AC[ai].occupancy:=xStrToFloat(SG1.Cells[8,ci]);
          AC[ai].CX:=AC[ai].X*TM[1,1]+AC[ai].Y*TM[1,2]+AC[ai].Z*TM[1,3];
          AC[ai].CY:=AC[ai].X*TM[2,1]+AC[ai].Y*TM[2,2]+AC[ai].Z*TM[2,3];
          AC[ai].CZ:=AC[ai].X*TM[3,1]+AC[ai].Y*TM[3,2]+AC[ai].Z*TM[3,3];
        end;
    end;
  // anions next
  for i := 1 to GAALength do
    begin
      ai:=i+AALength;ci:=i+nongen+GACLength;
      if pos('-',SG1.Cells[3,ci])<>0 then
        begin
          AA[ai].Atomlabel:=SG1.Cells[1,ci];
          AA[ai].Symbol:=SG1.Cells[2,ci];
          AA[ai].AtomSymbol:=SG1.Cells[11,ci];
          AA[ai].multiplicity:=StrToInt(SG1.Cells[4,ci]);
          PrevSep:=SG1.Cells[3,ci];
          GetCharge(Prevsep,Sgn,Charge);
          AA[ai].effcharge:=xStrToFloat(Sgn+Charge);;
          AA[ai].SymOp:=SG1.Cells[10,ci];
          AA[ai].RoString:=SG1.Cells[9,ci];
          AA[ai].X:=xStrToFloat(SG1.Cells[5,ci]);
          AA[ai].Y:=xStrToFloat(SG1.Cells[6,ci]);
          AA[ai].Z:=xStrToFloat(SG1.Cells[7,ci]);
          AA[ai].occupancy:=xStrToFloat(SG1.Cells[8,ci]);
          AA[ai].CX:=AA[ai].X*TM[1,1]+AA[ai].Y*TM[1,2]+AA[ai].Z*TM[1,3];
          AA[ai].CY:=AA[ai].X*TM[2,1]+AA[ai].Y*TM[2,2]+AA[ai].Z*TM[2,3];
          AA[ai].CZ:=AA[ai].X*TM[3,1]+AA[ai].Y*TM[3,2]+AA[ai].Z*TM[3,3];
        end;
    end;
  end;
end;

procedure LoadResults(ca:integer;SaveAs:boolean;FileName:string);

begin
  if ChardiIT and (iterations<>0) then
    IterationMethod:='  Iterations: '+inttostr(iterations)+' (CHARDI2015 method)'
  else if iterations<>0 then
    IterationMethod:='  Iterations: '+inttostr(iterations)+' (ECoN21 method)';
  case ca of
  1: DetCatList(not Hoppe.OmitCheckBox.Checked);
  2: ShortCatList;
  3: DetAnList(not Hoppe.OmitCheckBox.Checked);
  4: ShortAnList;
  5: LoadCatBonds;
  6: LoadShortCatBonds;
  7: LoadAnBonds;
  8: LoadShortAnBonds;
  end;
  if not Hoppe.AutosaveCheck.Checked then Hoppe.SaveAsButton.Enabled:=true;
end;

procedure ListResults(ResultsType:integer);
begin
  Hoppe.Memo1.Clear;
  case ResultsType of
  1: begin
       Hoppe.Memo1.Lines.Text := Output.Text;
       Output.Free;
       CurrentResults:=1;
       if Hoppe.AutosaveCheck.Checked then
       Hoppe.Memo1.Lines.SaveToFile(OutPath+Title+'-CC-D.out',TEncoding.UTF8);
       Hoppe.SectionCombo.Enabled:=true;
       with Hoppe.SectionCombo.Items do
        begin
          Clear;
          Add('   I. POLYHEDRA, SUBPOLYHEDRA - HSPj, DISTANCES - Rij, BOND WEIGHTS - wij, ECoN');
          Add('  II. DISTRIBUTION OF CATION CHARGES - Δqij AND CHARGES RECEIVED BY ANIONS - QA');
          Add(' III. DISTRIBUTION OF ANION CHARGES - ΔQij AND CHARGES RECEIVED BY CATIONS - QX');
          Add(' IVa. DISTRIBUTION OF BOND VALENCES - sij AND THE BOND VALENCE SUMS - BVS AROUND CATIONS');
          Add(' IVb. DISTRIBUTION OF BOND VALENCES - sij AND THE BOND VALENCE SUMS - BVS AROUND ANIONS');
          Add('   V. SYNOPSIS');
         end;
       Hoppe.SectionCombo.ItemIndex:=0;
       Hoppe.SectionComboLabel.Enabled:=true;
       if not ExZeroW then Hoppe.OmitCheckBox.Enabled:=true
       else
         begin
           Hoppe.OmitCheckBox.Checked:=False;
           Hoppe.OmitCheckBox.Enabled:=false;
         end;
       Hoppe.DetailedResults.Enabled:=true;
     end;
  2: begin
       Hoppe.Memo1.Lines.Text := Output1.Text;
       Output1.Free;
       CurrentResults:=2;
       if Hoppe.AutosaveCheck.Checked then
       Hoppe.Memo1.Lines.SaveToFile(OutPath+Title+'-CC-S.out',TEncoding.UTF8);
       Hoppe.SectionCombo.Enabled:=false;
       Hoppe.SectionCombo.ItemIndex:=-1;
       Hoppe.SectionComboLabel.Enabled:=false;
       Hoppe.OmitCheckBox.Enabled:=false;
       Hoppe.DetailedResults.Enabled:=true;
     end;
  3: begin
       Hoppe.Memo1.Lines.Text := Output2.Text;
       Output2.Free;
       CurrentResults:=3;
       if Hoppe.AutosaveCheck.Checked then
       Hoppe.Memo1.Lines.SaveToFile(OutPath+Title+'-AC-D.out',TEncoding.UTF8);
       Hoppe.SectionCombo.Enabled:=true;
       with Hoppe.SectionCombo.Items do
        begin
          Clear;
          Add('   I. POLYHEDRA, SUBPOLYHEDRA - HSPj, DISTANCES - Rij, BOND WEIGHTS - wij, ECoN');
          Add('  II. DISTRIBUTION OF CATION CHARGES - Δqij AND CHARGES RECEIVED BY ANIONS - QA');
          Add(' III. DISTRIBUTION OF ANION CHARGES - ΔQij AND CHARGES RECEIVED BY CATIONS - QX');
          Add(' IVa. DISTRIBUTION OF BOND VALENCES - sij AND THE BOND VALENCE SUMS - BVS AROUND ANIONS');
          Add(' IVb. DISTRIBUTION OF BOND VALENCES - sij AND THE BOND VALENCE SUMS - BVS AROUND CATIONS');
          Add('   V. SYNOPSIS');
        end;
       Hoppe.SectionCombo.ItemIndex:=0;
       Hoppe.SectionComboLabel.Enabled:=true;
       if not ExZeroW then Hoppe.OmitCheckBox.Enabled:=true
       else
         begin
           Hoppe.OmitCheckBox.Checked:=False;
           Hoppe.OmitCheckBox.Enabled:=false;
         end;
       Hoppe.DetailedResults.Enabled:=true;
     end;
  4: begin
       Hoppe.Memo1.Lines.Text := Output3.Text;
       Output3.Free;
       CurrentResults:=4;
       if Hoppe.AutosaveCheck.Checked then
       Hoppe.Memo1.Lines.SaveToFile(OutPath+Title+'-AC-S.out',TEncoding.UTF8);
       Hoppe.SectionCombo.Enabled:=false;
       Hoppe.SectionCombo.ItemIndex:=-1;
       Hoppe.SectionComboLabel.Enabled:=false;
       Hoppe.OmitCheckBox.Enabled:=false;
       Hoppe.DetailedResults.Enabled:=true;
     end;
  5: begin
       Hoppe.Memo1.Lines.Text := Output4.Text;
       Output4.Free;
       CurrentResults:=5;
       if Hoppe.AutosaveCheck.Checked then
       Hoppe.Memo1.Lines.SaveToFile(OutPath+Title+'-CC-D.pol',TEncoding.UTF8);
       Hoppe.SectionCombo.Enabled:=true;
       with Hoppe.SectionCombo.Items do
         begin
           Clear;
           Add('   I. COORDINATIONS, BOND LENGTHS, CENTROIDS, VOLUMES, DISTORTIONS');
           Add('  II. BOND ANGLES');
           Add(' III. DIHEDRAL ANGLES');
           Add('  IV. INTERLIGAND DISTANCES');
           Add('   V. DISTANCES TO THE NEAREST CENTRAL ATOMS');
           Add('  VI. SYNOPSIS');
         end;
       Hoppe.SectionCombo.ItemIndex:=0;
       Hoppe.SectionComboLabel.Enabled:=true;
       Hoppe.OmitCheckBox.Enabled:=false;
       Hoppe.DetailedResults.Enabled:=true;
     end;
  6: begin
       Hoppe.Memo1.Lines.Text := Output5.Text;
       Output5.Free;
       CurrentResults:=6;
       if Hoppe.AutosaveCheck.Checked then
       Hoppe.Memo1.Lines.SaveToFile(OutPath+Title+'-CC-S.pol',TEncoding.UTF8);
       Hoppe.SectionCombo.Enabled:=false;
       Hoppe.SectionCombo.ItemIndex:=-1;
       Hoppe.SectionComboLabel.Enabled:=false;
       Hoppe.OmitCheckBox.Enabled:=false;
       Hoppe.DetailedResults.Enabled:=true;
     end;
  7: begin
       Hoppe.Memo1.Lines.Text := Output6.Text;
       Output6.Free;
       CurrentResults:=7;
       if Hoppe.AutosaveCheck.Checked then
       Hoppe.Memo1.Lines.SaveToFile(OutPath+Title+'-AC-D.pol',TEncoding.UTF8);
       Hoppe.SectionCombo.Enabled:=true;
       Hoppe.SectionComboLabel.Enabled:=true;
       with Hoppe.SectionCombo.Items do
         begin
           Clear;
           Add('   I. COORDINATIONS, BOND LENGTHS, CENTROIDS, VOLUMES, DISTORTIONS');
           Add('  II. BOND ANGLES');
           Add(' III. DIHEDRAL ANGLES');
           Add('  IV. INTERLIGAND DISTANCES');
           Add('   V. DISTANCES TO THE NEAREST CENTRAL ATOMS');
           Add('  VI. SYNOPSIS');
         end;
       Hoppe.SectionCombo.ItemIndex:=0;
       Hoppe.OmitCheckBox.Enabled:=false;
       Hoppe.DetailedResults.Enabled:=true;
     end;
  8: begin
       Hoppe.Memo1.Lines.Text := Output7.Text;
       Output7.Free;
       CurrentResults:=8;
       if Hoppe.AutosaveCheck.Checked then
       Hoppe.Memo1.Lines.SaveToFile(OutPath+Title+'-AC-S.pol',TEncoding.UTF8);
       Hoppe.SectionCombo.Enabled:=false;
       Hoppe.SectionCombo.ItemIndex:=-1;
       Hoppe.SectionComboLabel.Enabled:=false;
       Hoppe.OmitCheckBox.Enabled:=false;
       Hoppe.DetailedResults.Enabled:=true;
     end;
  end;
end;

procedure Calculate;
var
  c1,c2,f: Int64;
begin
  QueryPerformanceFrequency(f);
  QueryPerformanceCounter(c1);
  InitializeRecords;
  Hoppe.PolGeomButton.Caption:='Coordination geometry';
  GetDistances(True);
  if not IsCoordination then Exit;
  Ortho;
  FixBondIndexes;
  FixPolyhedra;
  CalcFormula;
  //if Hoppe.Noniterative.Checked then NonIT:=true else NonIt:=false;
  NoBVS:=False;
  IteratedECoN;
  //if Hoppe.ChardiIteration.Checked then ChardiIT:=true else ChardiIT:=false;
  ShowingPolGeom:=False;
  if ShowCations then
    begin
      GreatIteration(1,EndItOption,ChardiIT);
      LoadSiblings;
      CalcGlobalInstabilityIndex;
      ChargeBalance(1);
      Distortions;
      CalcChargeFormula(1);
      CalcBVSFormula;
      CalcMAPD(1);
      SecondSphere(1);
      LigandsMAPD(1);
      QueryPerformanceCounter(c2);
      timeelapsed1:=(c2-c1)/f;
      if Hoppe.DetailedResults.Checked then
        begin
          LoadResults(1,False,'');
          ListResults(1);
        end
      else
        begin
          LoadResults(2,False,'');
          ListResults(2);
        end;
    end
  else
    begin
      GreatIteration(2,EndItOption,ChardiIT);
      LoadSiblings;
      CalcGlobalInstabilityIndex;
      ChargeBalance(2);
      Distortions;
      CalcChargeFormula(2);
      CalcBVSFormula;
      CalcMAPD(2);
      SecondSphere(2);
      LigandsMAPD(2);
      QueryPerformanceCounter(c2);
      timeelapsed2:=(c2-c1)/f;
      if Hoppe.DetailedResults.Checked then
        begin
          LoadResults(3,False,'');
          ListResults(3);
        end
      else
        begin
          LoadResults(4,False,'');
          ListResults(4);
        end;
    end;
  Calculated:=True;
  Hoppe.CalculateButton.Enabled:=false;
  Hoppe.ShowXcenteredButton.Enabled:=true;
  Hoppe.PolGeomButton.Enabled:=true;
end;

procedure CalcMultiplicities;
var
 h,i,j,k,o:integer;
 al,pss,sk:string;
 Siblingatoms:array[1..200] of integer;

begin
  with Hoppe do
  begin
    o:=ACLength+AALength;
    for i:=1 to o do
      begin
        k:=1;
        for h:=1 to 200 do SiblingAtoms[h]:=0;
        SiblingAtoms[1]:=i;
        al:=SG1.Cells[1,i];
          for j:=o+1 to SG1.RowCount-1 do
            begin
              pss:=Star(SG1.Cells[1,j]);
              if pss=al then
                begin
                  inc(k);
                  Siblingatoms[k]:=j;
                end;
            end;
        sk:=IntToStr(k);
        SG1.Cells[4,i]:=sk;
        for h:=1 to k do SG1.Cells[4,SiblingAtoms[h]]:=sk;
      end;
  end;
end;

procedure GenerateAtoms;
var
  Args:array [0..2] of extended;
  col,i,j,ii,r,nd:integer;
  ps,ProvFormula,ProvX,ProvY,ProvZ,compX,compY,compZ,compcellX,compcellY,compcellZ,decmod:string;
  ProvCoord:extended;
  AtomReject:boolean;

begin
   GACLength:=0;GAALength:=0;
   nd:=Decimals;
   with Hoppe do
   begin
   for i:=1 to ACLength do
     begin
       for j:=1 to SymOpArray.Count-1 do
          begin
            for col:=0 to 2 do
              begin
                ProvFormula:=GetCol(',',SymOpArray[j],col);
                TrimLeft(ProvFormula);
                Variables.Lines.Clear;
                Values.Lines.Clear;
                if pos('x',Provformula)>0 then
                  begin
                   Variables.Lines.Add('x');
                   Values.Lines.Add(xFloatToStr(AC[i].X));
                  end;
                if pos('y',Provformula)>0 then
                  begin
                    Variables.Lines.Add('y');
                    Values.Lines.Add(xFloatToStr(AC[i].Y));
                  end;
                if pos('z',Provformula)>0 then
                  begin
                    Variables.Lines.Add('z');
                    Values.Lines.Add(xFloatToStr(AC[i].Z));
                  end;
                CE.Formula:=ProvFormula;
                CE.Variables:=Variables.Lines;
                for ii := 0 to Values.Lines.Count-1 do
                  args[ii]:=xStrToFloat(Values.Lines[ii]);
                ProvCoord:=CE.calc(args);
                ProvCoord:=Fmod(3+ProvCoord,1);
                decmod:=DecForm(nd);
                ps:=FF('0.'+decmod,ProvCoord);
                if ps='1.'+decmod then ProvCoord:=0;
                case col of
                  0: ProvX:=FF('0.'+decmod,ProvCoord);
                  1: ProvY:=FF('0.'+decmod,ProvCoord);
                  2: ProvZ:=FF('0.'+decmod,ProvCoord);
                end;
              end;
              AtomReject:=false;
              for r := 1 to SG1.RowCount-1 do
                begin
                  compx:=copy(ProvX,1,7);compy:=copy(ProvY,1,7);compZ:=copy(ProvZ,1,7);
                  compcellX:=copy(SG1.Cells[5,r],1,7);
                  compcellY:=copy(SG1.Cells[6,r],1,7);
                  compcellZ:=copy(SG1.Cells[7,r],1,7);
                  if EqualCoords(compX,compcellX) and
                     EqualCoords(compY,compcellY) and
                     EqualCoords(compZ,compcellZ) then AtomReject:=true;
                end;
                if not AtomReject then
                  with SG1 do
                    begin
                      Cells[1,SG1.RowCount]:='*'+AC[i].AtomLabel;
                      Cells[2,SG1.RowCount]:=AC[i].symbol;
                      Cells[11,SG1.RowCount]:=AC[i].AtomSymbol;
                      ps:=FF('0.000',AC[i].effcharge);
                      Cells[3,SG1.RowCount]:=ps;
                      Cells[4,SG1.RowCount]:=FF('0',AC[i].Multiplicity);
                      Cells[5,SG1.RowCount]:=ProvX;
                      Cells[6,SG1.RowCount]:=ProvY;
                      Cells[7,SG1.RowCount]:=ProvZ;
                      Cells[8,SG1.RowCount]:=FF('0.000',AC[i].occupancy);
                      Cells[9,SG1.RowCount]:=AC[i].RoString;
                      Cells[10,SG1.RowCount]:=ElimBlanks(SymOpArray[j]);
                      GACLength:=GACLength+1;
                      RowCount:=SG1.RowCount+1;
                  end;
          end;       //end of SymOpArray
     end;           //end of generating cations
   for i:=1 to AALength do
     begin
       for j:=1 to SymOpArray.Count-1 do
         begin
           for col:=0 to 2 do
             begin
               ProvFormula:=GetCol(',',SymOpArray[j],col);
               Variables.Lines.Clear;
               Values.Lines.Clear;
               if pos('x',Provformula)>0 then
                 begin
                   Variables.Lines.Add('x');
                   Values.Lines.Add(xFloatToStr(AA[i].X));
                 end;
                 if pos('y',Provformula)>0 then
                   begin
                     Variables.Lines.Add('y');
                     Values.Lines.Add(xFloatToStr(AA[i].Y));
                   end;
                 if pos('z',Provformula)>0 then
                   begin
                     Variables.Lines.Add('z');
                     Values.Lines.Add(xFloatToStr(AA[i].Z));
                   end;
                 CE.Formula:=ProvFormula;
                 CE.Variables:=Variables.Lines;
                 for ii := 0 to Values.Lines.Count-1 do
                     args[ii]:=xStrToFloat(Values.Lines[ii]);
                 ProvCoord:=CE.calc(args);
                 ProvCoord:=Fmod(3+ProvCoord,1);
                 ps:=FF('0.'+decmod,ProvCoord);
                 if ps='1.'+decmod then ProvCoord:=0;
                 case col of
                   0: ProvX:=FF('0.'+decmod,ProvCoord);
                   1: ProvY:=FF('0.'+decmod,ProvCoord);
                   2: ProvZ:=FF('0.'+decmod,ProvCoord);
                 end;
             end;
           AtomReject:=false;
           for r := 1 to SG1.RowCount-1 do
           if pos('-',SG1.Cells[3,r])<>0 then
             begin
               compx:=copy(ProvX,1,7);compy:=copy(ProvY,1,7);compZ:=copy(ProvZ,1,7);
               compcellX:=copy(SG1.Cells[5,r],1,7);
               compcellY:=copy(SG1.Cells[6,r],1,7);
               compcellZ:=copy(SG1.Cells[7,r],1,7);
               if EqualCoords(compX,compcellX) and
                  EqualCoords(compY,compcellY) and
                  EqualCoords(compZ,compcellZ) then AtomReject:=true;
             end;
              if not AtomReject then
                with SG1 do
                  begin
                    Cells[1,SG1.RowCount]:='*'+AA[i].AtomLabel;
                    Cells[2,SG1.RowCount]:=AA[i].symbol;
                    Cells[11,SG1.RowCount]:=AA[i].AtomSymbol;
                    ps:=FF('0.000',AA[i].effcharge);
                    Cells[3,SG1.RowCount]:=ps;
                    Cells[4,SG1.RowCount]:=FF('0',AA[i].Multiplicity);
                    Cells[5,SG1.RowCount]:=ProvX;
                    Cells[6,SG1.RowCount]:=ProvY;
                    Cells[7,SG1.RowCount]:=ProvZ;
                    Cells[8,SG1.RowCount]:=FF('0.000',AA[i].occupancy);
                    Cells[9,SG1.RowCount]:=AA[i].RoString;
                    Cells[10,SG1.RowCount]:=ElimBlanks(SymOpArray[j]);
                    GAALength:=GAALength+1;
                    RowCount:=SG1.RowCount+1;
                end;
         end;
     end;      //end of generating anions
   end;
end;

procedure THoppe.OmitCheckBoxClick(Sender: TObject);
begin
   if Calculated then
    begin
      LoadResults(CurrentResults,False,'');
      ListResults(CurrentResults);
    end;
end;

procedure THoppe.OneStepClick(Sender: TObject);
begin
   if Title<>'' then CalculateButton.Enabled:=true;
end;

procedure THoppe.OpenCifFile(Sender: TObject);

var
i,j,n,Cindex,p,r,rindex,w,ww,ocindex,errind,textwidth,nd:integer;
ProvCoord,Valcharge,mergedocc,valocc,valocc1,Fcharge1,Fcharge2,ch:extended;
CifText,OCoord,OAtoms,FCoord,ChList:TStringList;
finishreading,IsMult,HaveCharges,SymCardinals:boolean;
rcols:array[0..7] of integer;
ps,ps1,Cifline,SCharge1,SCharge2,SSgn1,SSgn2,OCLine,ssym,scoor,compsym,compcoor,decmod:string;
c1,c2,f: Int64;
x1,x2,y1,y2,z1,z2:real;

begin
  IsHydrogen:=false;
  ExZeroW:=false;
  FileOpenDialog1.FileName:='*.cif';
  FileOpenDialog1.FileNameLabel:='CIF files';
  if FileOpenDialog1.execute then
    begin
      ShowCations:=true;
      QueryPerformanceFrequency(f);
      QueryPerformanceCounter(c1);
      //Initialize variables for cif file reading
      with Hoppe do
        begin
          SectionCombo.Enabled:=False;
          SectionCombo.ItemIndex:=-1;
          SectionComboLabel.Enabled:=False;
          ShowXcenteredButton.Enabled:=false;
          ShowXcenteredButton.Caption:='>> Anion-centered';
          SaveAsButton.Enabled:=False;
        end;
      ShowCations:=true;
      NearestLimit:=false;
      Title:=FileOpenDialog1.FileName;
      Title:=ExtractFileName(Title);
      if pos('.cif',Title)<>0 then delete(Title,pos('.cif',Title),4);
      OutPath:=ExtractFilePath(FileOpenDialog1.FileName);
      finishreading:=false;
      alpha:=''; beta:='';gamma:='';
      a:='';b:='';c:='';
      SymList:=False; n:=0; HaveCharges:=false;
      isMult:=False;
      NoBVS:=False;
      SymCardinals:=False;
      GotMaxLengths:=False;
      InitializeRecords;
      AtomrecordClear;
      for i:=1 to SG1.RowCount-1 do
        for j:=0 to SG1.ColCount-1 do
          SG1.Cells[j,i]:='';
      for i:=1 to SG2.RowCount-1 do
        for j:=0 to SG2.ColCount-1 do
          SG2.Cells[j,i]:='';
      SG1.RowCount:=100;SG2.RowCount:=100;
      Memo1.Clear;
      CifText:=TStringList.Create;
      CifText.LoadFromFile(FileOpenDialog1.FileName);
      Ciftext.Add(' ');
      ps:=' '+FileOpenDialog1.FileName+' ';
      textwidth:=GetTextWidth(ps,FileNamePanel.Font);
      if textwidth<FileNamePanel.width then
        FileNamePanel.Alignment:=taLeftJustify
      else
        FileNamePanel.Alignment:=taRightJustify;
      FileNamePanel.Caption:=ps;
      while not finishreading do
         begin
           CifLine:=RepTabs(CifText[n]);
           Cifline:=ElimDupBlanks(CifLine);
           Cifline:=ElimLeadBlanks(CifLine);
           // READ UNIT CELL PARAMETERS
           if pos('_cell_length_a',Cifline)>0 then
             begin
               a:=ElimESD(GetCol(' ',CifLine,1));
               a:=ElimFinPoint(a);
               Val(a,provcoord,j);
               if j<>0 then
                 begin
                   ShowMessage('Invalid unit-cell parameters.');
                   Exit;
                 end;
               aPanel.Caption:=a;
             end;
           if pos('_cell_length_b',Cifline)>0 then
             begin
               b:=ElimESD(GetCol(' ',CifLine,1));
               b:=ElimFinPoint(b);
               Val(b,provcoord,j);
               if j<>0 then
                 begin
                   ShowMessage('Invalid unit-cell parameters.');
                   Exit;
                 end;
               bPanel.Caption:=b;
             end;
           if pos('_cell_length_c',Cifline)>0 then
             begin
               c:=ElimESD(GetCol(' ',CifLine,1));
               c:=ElimFinPoint(c);
               Val(c,provcoord,j);
               if j<>0 then
                 begin
                   ShowMessage('Invalid unit-cell parameters.');
                   Exit;
                 end;
               cPanel.Caption:=c;
             end;
           if pos('_cell_angle_alpha',Cifline)>0 then
             begin
               alpha:=ElimESD(GetCol(' ',CifLine,1));
               alpha:=ElimFinPoint(alpha);
               if (alpha='?') or (alpha='') then alpha:='90';
               Val(alpha,provcoord,j);
               if j<>0 then
                 begin
                   ShowMessage('Invalid unit-cell parameters.');
                   Exit;
                 end;
               alphaPanel.Caption:=alpha;
             end;
           if pos('_cell_angle_beta',Cifline)>0 then
             begin
               beta:=ElimESD(GetCol(' ',CifLine,1));
               beta:=ElimFinPoint(beta);
               if (beta='?') or (beta='') then beta:='90';
               Val(beta,provcoord,j);
               if j<>0 then
                 begin
                   ShowMessage('Invalid unit-cell parameters.');
                   Exit;
                 end;
               betaPanel.Caption:=beta;
             end;
           if pos('_cell_angle_gamma',Cifline)>0 then
             begin
               gamma:=ElimESD(GetCol(' ',CifLine,1));
               gamma:=ElimFinPoint(gamma);
               if (gamma='?') or (gamma='') then gamma:='90';
               Val(gamma,provcoord,j);
               if j<>0 then
                 begin
                   ShowMessage('Invalid unit-cell parameters.');
                   Exit;
                 end;
               gammaPanel.Caption:=gamma;
             end;
           //READ SPACE GROUP
           if pos('H-M',Cifline)>0 then
             begin
               p:=pos(#39,Cifline);r:=pos(#8217,Cifline);
               if (p>0) or (r>0) then
                 begin
                   if p>0 then Delete(Cifline,1,p-1) else Delete(Cifline,1,r-1);
                   spacegroup:=Shave(Cifline);
                 end
               else
                 begin
                   Delete(CifLine,1,pos(' ',Cifline));
                   TrimLeft(Cifline);
                   spacegroup:=Cifline;
                 end;
               SpaceGroupPanel.Caption:=spacegroup;
             end;
           //READ SYMMETRY OPERATIONS
           if (pos('_space_group_symop_id',CifLine)<>0) or
              (pos('_symmetry_equiv_pos_site_id',Cifline)<>0) then SymCardinals:=True;
           if (pos('_space_group_symop_operation_xyz',Cifline)>0) or
              (pos('_symmetry_equiv_pos_as_xyz',Cifline)>0) then
             begin
               SymList:=true;
               SymOpArray:=TStringList.create;
               cindex:=1;SymOpArray.Add('x,y,z');
               repeat
                 Cifline:=RepTabs(Ciftext[n+cindex]);
                 Cifline:=ElimDupBlanks(CifLine);
                 CifLine:=ElimLeadBlanks(CifLine);
                 if CifLine='' then
                   begin
                     inc(cindex);
                     p:=1;
                   end
                 else
                   begin
                    if SymCardinals  then
                      begin
                        if pos(', ',CifLine)<>0 then CifLine:=ElimBlanksInSymOp(CifLine);
                        CifLine:=GetCol(' ',Cifline,1);
                      end;
                    p:=pos(',',Cifline); r:=pos(#8217,Cifline); w:=pos(#39,Cifline);
                    ps:=Cifline;
                    if (r>0) or (w>0) then
                      begin
                        if r>0 then Delete(CifLine,1,r-1);
                        if w>0 then Delete(Cifline,1,w-1);
                        ps:=Shave(Cifline);
                      end
                    else
                      ps:=Cifline;
                      ps:=ElimBlanks(ps);
                      ps:=ElimQuotes(ps);
                      if (p<>0) and (ps<>'x,y,z') then SymOpArray.Add(ps);
                      inc(cindex);
                   end;
               until
                 p=0;
             end;

           //READ CHARGES FROM SEPARATE LIST IF ANY
           if ((pos('_atom_type_symbol',Cifline)=1) or (pos('_atom_site_label',Cifline)=1)) then
           if (pos('_atom_type_oxidation_number',Ciftext[n+1])=1) and
              ((pos(' ',Ciftext[n+2])<>0) or (pos(#9,Ciftext[n+2])<>0)) then
             begin
               ChList:=TStringList.Create;
               ChList.Sorted:=true;
               ChList.Duplicates:=dupIgnore;
               try
                 HaveCharges:=true;
                 cindex:=2;
                 Cifline:=RepTabs(Ciftext[n+cindex]);
                 Cifline:=ElimDupBlanks(CifLine);
                 CifLine:=ElimLeadBlanks(CifLine);
                 if (pos('_atom_type_symbol',Ciftext[n])>0) then
                   begin
                     ChMemo.Clear;
                     cindex:=2;
                     repeat
                       Cifline:=RepTabs(Ciftext[n+cindex]);
                       Cifline:=ElimDupBlanks(CifLine);
                       CifLine:=ElimLeadBlanks(CifLine);
                       CifLine:=ElimEndBlanks(CifLine);
                       if Cifline='' then p:=0
                       else
                        begin
                          p:=1;
                          if IsNumber(CifLine) then
                            begin
                              ps1:=GetCol(' ',Cifline,0);
                              ps:=GetSymbol(ps1);
                              if not ValidSymbol(ps) then
                                begin
                                  ShowMessage(ps+' is not a valid chemical symbol.');
                                  Exit;
                                end;
                              ps1:=GetCol(' ',Cifline,1);
                              GetCharge(ps1,Sgn,Charge);
                              Val(Charge,ch,j);
                              if (j<>0) or (Charge='9.999') then
                                begin
                                  ShowMessage('Error reading charges.');
                                  Exit;
                                end;
                                ChList.Add(CifLine);
                                inc(cindex);
                            end
                          else
                            p:=0;
                        end;
                     until (p=0);
                     ChMemo.Text:=ChList.Text;
                   end;
               finally
                 ChList.Free;
               end;
               Cifline:='';
             end;
           //READ ATOMIC COORDINATES, SYMMETRY MULTIPLICITIES, CHARGES,OCCUPANCIES
           //READ FLAGS AND ASSIGN TO COLUMNS IN THE COORDINATIONS TABLE
           if (pos('_atom_site_label',CifLine)=1) or (pos('_atom_site_type_symbol',CifLine)=1) or
              (pos('_atom_site_symmetry_multiplicity',CifLine)=1) or (pos('_atom_site_fract_x',CifLine)=1) or
              (pos('_atom_site_fract_y',Cifline)=1) or (pos('_atom_site_fract_z',Cifline)=1) or
              (pos('_atom_site_occupancy',Cifline)=1) or (pos('_atom_site_oxidation_number',Cifline)=1) then
             begin
               for j := 0 to 7 do rcols[j]:=-1;
               ACLength:=0;AALength:=0;
               rindex:=1;
               cindex:=0;
                 repeat
                   CifLine:=RepTabs(Ciftext[n+Cindex]);
                   Cifline:=ElimDupBlanks(CifLine);
                   CifLine:=ElimLeadBlanks(CifLine);
                   p:=pos('_',Cifline);
                   if p>0 then
                     begin
                       if pos('_atom_site_label',CifLine)<>0 then rcols[0]:=cindex;
                       if pos('_atom_site_type_symbol',CifLine)<>0 then rcols[1]:=cindex;
                       if pos('_atom_site_symmetry_multiplicity',CifLine)<>0 then rcols[3]:=cindex;
                       if pos('_atom_site_oxidation_number',CifLine)<>0 then rcols[2]:=cindex;
                       if pos('_atom_site_fract_x',CifLine)<>0 then rcols[4]:=cindex;
                       if pos('_atom_site_fract_y',CifLine)<>0 then rcols[5]:=cindex;
                       if pos('_atom_site_fract_z',CifLine)<>0 then rcols[6]:=cindex;
                       if pos('_atom_site_occupancy',CifLine)<>0 then rcols[7]:=cindex;
                     end;
                   inc(cindex);
                 until
                   p=0;
               if rcols[0]=-1 then
                 begin
                   ShowMessage('Missing atom label in the _atom_site section.');
                   Exit;
                 end;
               if rcols[1]=-1 then
                 begin
                   ShowMessage('Missing atom symbol in the _atom_site section. No Bond Valence Sums will be calculated.' );
                   NoBVS:=True;;
                 end;
                if (rcols[4]=-1) or (rcols[5]=-1) or (rcols[6]=-1) then
                  begin
                    ShowMessage('Missing atom coordinate in the _atom_site section.');
                    Exit;
                  end;
                if rcols[7]=-1 then
                  begin
                    ShowMessage('Error reading occupancies.');
                    Exit;
                  end;

               //START READING ACTUAL COORDINATES AND STUFF
               //the following sorts the list of coordinates:
               // 1. Separates cations from anions
               // 2. Groups and orders atoms by atom label
               // 3. Brings mixed sites together if apart in the list
               OCoord:=TStringList.Create;OCLine:='';
               OAtoms:=TStringList.Create;
               ocindex:=cindex-1;
               try
                 repeat
                   OCLine:=RepTabs(CifText[n+ocindex]);
                   OCLine:=ElimDupBlanks(OCLine);
                   OCLine:=ElimLeadBlanks(OCLine);
                   if OCLine='' then
                     begin
                       inc(ocindex);
                       p:=0;
                     end
                   else
                     begin
                       p:=pos('.',OCLine);
                       if p<>0 then OCoord.Add(ElimESD(OCLine));
                       inc(ocindex);
                     end;
                 until
                  p=0;
                 for i:=0 to OCoord.Count-1 do
                   begin
                     OCLine:=OCoord[i];
                     if pos('+',OCLine)<>0 then
                       OAtoms.Add(OCLine);
                   end;
                 for i:=0 to OCoord.Count-1 do
                   begin
                     OCLine:=OCoord[i];
                     if pos('+',OCLine)=0 then
                       OAtoms.Add(OCLine);
                   end;
                 FCoord:=TStringList.Create;;
                 for i:=0 to OAtoms.Count-1 do
                   begin
                     OCLine:=OAtoms[i];
                     if pos('#',OCLine)=0 then
                       begin
                         FCoord.Add(OCLine);
                         scoor:=GetCol(' ',OCLine,rcols[5]);
                         DecimalsNo:=CoordDecimals(scoor);
                         ssym:=GetCol(' ',OCLine,rcols[1]);
                         scoor:=GetCol(' ',OCLine,rcols[4])+
                                GetCol(' ',OCLine,rcols[5])+
                                GetCol(' ',OCLine,rcols[6]);
                         for j:=i+1 to OAtoms.Count-1 do
                           begin
                            compsym:=GetCol(' ',OAtoms[j],rcols[1]);
                            compcoor:=GetCol(' ',OAtoms[j],rcols[4])+
                                      GetCol(' ',OAtoms[j],rcols[5])+
                                      GetCol(' ',OAtoms[j],rcols[6]);
                            if (scoor=compcoor) and (pos('#',OAtoms[j])=0) then
                              begin
                                FCoord.Add(OAtoms[j]);
                                OAtoms[j]:='#'+OAtoms[j];
                              end;
                           end;
                       end;
                   end;
               finally
                 OCoord.Free;OAtoms.Free;
               end;
               rindex:=1;
               cindex:=cindex-1;
               for ww:=0 to FCoord.Count-1 do
                 begin
                   Cifline:=RepTabs(FCoord[ww]);
                   ps:=GetCol(' ',Cifline,rcols[0]);
                   SG1.Cells[1,rindex]:=GetCol(' ',Cifline,rcols[0]);
                   ps:=GetCol(' ',Cifline,rcols[1]);
                   ps:=GetSymbol(ps);
                   if not ValidSymbol(ps) then
                     begin
                       ShowMessage(ps+' is not a valid chemical symbol.');
                       Exit;
                     end;
                   SG1.Cells[11,rindex]:=ps;
                   SG1.Cells[2,rindex]:=ps;
                   SG1.Cells[9,rindex]:=SG1.Cells[2,rindex];
                   ps:=ElimESD(GetCol(' ',Cifline,rcols[4]));
                   if ps<>'' then
                     begin
                       Val(ps,ProvCoord,errind);
                       if errind<>0 then
                         begin
                           ShowMessage('Error reading atom coordinates - '+SG1.Cells[1,rindex]);
                           Exit;
                         end;
                       nd:=CoordDecimals(ps);
                       decmod:=DecForm(nd);
                       ProvCoord:=xStrToFloat(ps);
                       if (ProvCoord<0) or (ProvCoord>1) then ProvCoord:=Fmod(10+ProvCoord,1);
                       if ProvCoord=1 then  ProvCoord:=0;
                       SG1.Cells[5,rindex]:=FF(decmod,ProvCoord);
                     end
                   else
                     begin
                       ShowMessage('Error reading atom coordinates - '+SG1.Cells[1,rindex]);
                       Exit;
                     end;
                   ps:=ElimESD(GetCol(' ',Cifline,rcols[5]));
                   if ps<>'' then
                     begin
                       Val(ps,ProvCoord,errind);
                       if errind<>0 then
                         begin
                           ShowMessage('Error reading atom coordinates - '+SG1.Cells[1,rindex]);
                           Exit;
                         end;
                       nd:=CoordDecimals(ps);
                       decmod:=DecForm(nd);
                       ProvCoord:=xStrToFloat(ps);
                       if (ProvCoord<0) or (ProvCoord>1) then ProvCoord:=Fmod(10+ProvCoord,1);
                       if ProvCoord=1 then  ProvCoord:=0;
                       SG1.Cells[6,rindex]:=FF(decmod,ProvCoord);
                     end
                   else
                     begin
                       ShowMessage('Error reading atom coordinates - '+SG1.Cells[1,rindex]);
                       Exit;
                     end;
                   ps:=ElimESD(GetCol(' ',Cifline,rcols[6]));
                   if ps<>'' then
                     begin
                       Val(ps,ProvCoord,errind);
                       if errind<>0 then
                         begin
                           ShowMessage('Error reading atom coordinates - '+SG1.Cells[1,rindex]);
                           Exit;
                         end;
                       nd:=CoordDecimals(ps);
                       decmod:=DecForm(nd);
                       ProvCoord:=xStrToFloat(ps);
                       if (ProvCoord<0) or (ProvCoord>1) then ProvCoord:=Fmod(10+ProvCoord,1);
                       if ProvCoord=1 then  ProvCoord:=0;
                       SG1.Cells[7,rindex]:=FF(decmod,ProvCoord);
                     end
                   else
                     begin
                       ShowMessage('Error reading atom coordinates - '+SG1.Cells[1,rindex]);
                       Exit;
                     end;
                   ps:=ElimESD(GetCol(' ',Cifline,rcols[7]));
                   Val(ps,provCoord,errind);
                   if (errind<>0) then
                     begin
                       ShowMessage('Error reading occupancies.');
                       Exit;
                     end;
                   if ps<>'' then
                     begin
                       SG1.Cells[8,rindex]:=FormatString(ps,'0.000');
                       SG1.Cells[2,rindex]:=SG1.Cells[8,rindex]+'.'+SG1.Cells[2,rindex];
                     end
                   else
                     begin
                       ShowMessage('Error reading occupancies.');
                       Exit;
                     end;
                   if not HaveCharges then
                     begin
                       if rcols[2]<>-1 then ps:=GetCol(' ',Cifline,rcols[2])
                       else ps:=GetCol(' ',Cifline,rcols[1]);
                       GetCharge(ps,Sgn,Charge);
                       Val(Charge,ch,j);
                       if (j<>0) or (Charge='9.999') then
                         begin
                           ShowMessage('Error reading charges.');
                           Exit;
                         end;
                       SG1.Cells[9,rindex]:=SG1.Cells[9,rindex].PadRight(3)+Sgn+Charge+
                                        ' '+SG1.Cells[8,rindex];
                       Valocc:=xStrToFloat(SG1.Cells[8,rindex]);
                       Valcharge:=xStrToFloat(Charge);
                       Valcharge:=ValCharge*Valocc;
                       Charge:=FF('0.000',Valcharge);
                       ps:= (Sgn+FormatString(Charge,'0.000'));
                       SG1.Cells[3,rindex]:=ps;
                     end
                   else
                     if ChMemo.Text<>'' then
                       begin
                         for i:=0 to ChMemo.Lines.Count-1 do
                           begin
                             ps:=GetCol(' ',ChMemo.Lines[i],1);
                             ps:=GetCharge(ps,Sgn,Charge);
                             Val(Charge,ch,j);
                              if (j<>0) or (Charge='9.999') then
                                begin
                                  ShowMessage('Error reading charges.');
                                  Exit;
                                end;
                             if GetCol(' ',ChMemo.Lines[i],0)=GetCol(' ',Cifline,rcols[1]) then
                               begin
                                 SG1.Cells[9,rindex]:=SG1.Cells[9,rindex].PadRight(3)+Sgn+Charge+
                                                  ' '+SG1.Cells[8,rindex];
                                 Valocc:=xStrToFloat(SG1.Cells[8,rindex]);
                                 Valcharge:=xStrToFloat(Charge);
                                 Valcharge:=ValCharge*Valocc;
                                 Charge:=FF('0.000',Valcharge);
                                 if Sgn='-' then ps:=(Sgn+Charge)
                                 else ps:=Charge;
                                 SG1.Cells[3,rindex]:= ps;
                               end;
                           end;
                       end;
                   // See about mixed sites
                   if rindex>1 then
                    begin
                      x1:=XStrToFloat(SG1.Cells[5,rindex]);x2:=XStrToFloat(SG1.Cells[5,rindex-1]);
                      y1:=XStrToFloat(SG1.Cells[6,rindex]);y2:=XStrToFloat(SG1.Cells[6,rindex-1]);
                      z1:=XStrToFloat(SG1.Cells[7,rindex]);z2:=XStrToFloat(SG1.Cells[7,rindex-1]);
                    end;
                   if (rindex>1) and (abs(x1-x2)<0.000010) and (abs(y1-y2)<0.000010)
                                 and (abs(z1-z2)<0.000010) then
                     begin
                       //merge symbols
                       SG1.Cells[11,rindex-1]:=SG1.Cells[11,rindex-1]+'-'+SG1.Cells[11,rindex];
                       //merge site population
                       SG1.Cells[2,rindex-1]:=SG1.Cells[2,rindex-1]+':'+SG1.Cells[2,rindex];
                       // merge labels
                       SG1.Cells[1,rindex-1]:=SG1.Cells[1,rindex-1]+'-'+SG1.Cells[1,rindex];
                       //correct occupancy
                       Val(SG1.Cells[8,rindex-1],valocc,j);
                       if j<>0 then
                         begin
                           ShowMessage('Error reading occupancies.');
                           Exit;
                         end;
                       Val(SG1.Cells[8,rindex],valocc1,j);
                       if j<>0 then
                         begin
                           ShowMessage('Error reading occupancies.');
                           Exit;
                         end;
                       mergedocc:=valocc+valocc1;
                       SG1.Cells[8,rindex-1]:=FF('0.000',mergedocc);
                       // correct oxidation number
                       if IsNumber(SG1.Cells[3,rindex-1]) then
                         begin
                           GetCharge(SG1.Cells[3,rindex-1],Sgn,Charge);
                           Scharge1:=Charge;SSgn1:=Sgn;
                           Val(SCharge1,Fcharge1,j);
                           if (j<>0) or (Charge='9.999') then
                             begin
                               ShowMessage('Error reading charges.');
                               Exit;
                             end;
                         end
                       else
                         begin
                           ShowMessage('Error reading charges.');
                           Exit;
                         end;
                       if IsNumber(SG1.Cells[3,rindex]) then
                         begin
                           GetCharge(SG1.Cells[3,rindex],Sgn,Charge);
                           Scharge2:=Charge;SSgn2:=Sgn;
                           Val(SCharge2,Fcharge2,j);
                           if (j<>0) or (Charge='9.999') then
                             begin
                               ShowMessage('Error reading charges.');
                               Exit;
                             end;
                         end
                       else
                         begin
                           ShowMessage('Error reading charges.');
                           Exit;
                         end;
                       mergedocc:=Fcharge1+Fcharge2;
                       ps:=(Sgn+FormatString(xFloatToStr(mergedocc),'0.000'));
                       SG1.Cells[3,rindex-1]:=ps{+Sgn};
                       SG1.Cells[9,rindex-1]:=SG1.Cells[9,rindex-1]+','+SG1.Cells[9,rindex];
                       // delete merged
                       for i := 0 to 10 do SG1.Cells[i,rindex]:='';
                       for i := rindex to SG1.RowCount - 2 do
                       SG1.Rows[i].CommaText := SG1.Rows[i+1].CommaText;
                       rindex:=rindex-1;
                     end;       // end merge mixed sites
                     inc(rindex); inc(cindex);//SG1.rowcount:=SG1.RowCount+1;
                 end;  //end main repeat cycle
               finishreading:=true;
             end;  // end of reading coordinate flags and table
           n:=n+1;
         end;  // while not finishreading
         FCoord.Free;
         for i:=1 to rindex-1 do
         begin
           GetCharge(SG1.Cells[3,i],Sgn,Charge);
           if Sgn<>'-' then ACLength:=ACLength+1
           else AALength:=AALength+1;
         end;
       SG1.RowCount:=ACLength+AALength+1;
       FreeandNil(Ciftext);
       PrepareUnitCell;
       TransformationMatrix;
       LoadRecords;
       if SymList then
         begin
           GenerateAtoms;
           if not IsMult then CalcMultiplicities;
           LoadRecords;
           LoadGeneratedRecords;
         end
       else
         if spacegroup<>'P 1' then
           begin
             ShowMessage('No symmetry operators found.');
             Exit;
           end;
      for i:=1 to SG1.RowCount-1 do SG1.Cells[0,i]:=IntToStr(i);
      SG2.RowCount:=SG1.RowCount;
      if SG2.RowCount<100 then SG2.RowCount:=200;
      StrPosCharge:=0;StrNegCharge:=0;
      nd:=Decimals;
      decmod:=DecForm(nd);
      for i:=1 to SG1.RowCount-1 do
        begin
          if pos('-',SG1.Cells[3,i])<>0 then StrNegCharge:=StrNegCharge+xStrToFloat(SG1.Cells[3,i])
            else StrPosCharge:=StrPosCharge+xStrToFloat(SG1.Cells[3,i]);
          for j:=0 to 11 do
            if (j<3) then
              SG2.Cells[j,i]:=SG1.Cells[j,i]
            else
              case j of
                3: SG2.Cells[j,i]:=SG1.Cells[j,i].PadLeft(8);
                4: SG2.Cells[j,i]:=SG1.Cells[j,i].PadLeft(5);
                5: begin
                     ps:=FormatString(SG1.Cells[j,i],decmod);
                     SG2.Cells[j,i]:=ps.PadLeft(9);
                   end;
                6: begin
                     ps:=FormatString(SG1.Cells[j,i],decmod);
                     SG2.Cells[j,i]:=ps.PadLeft(9);
                   end;
                7: begin
                     ps:=FormatString(SG1.Cells[j,i],decmod);
                     SG2.Cells[j,i]:=ps.PadLeft(9);
                   end;
                8: SG2.Cells[j,i]:=SG1.Cells[j,i].PadLeft(7);
              end;
        end;
      ParaSymbols;
      ITModified:=False;
      RadModified:=False;
      Calculated:=False;
      BondsButton.Enabled:=true;
      CalculateButton.Enabled:=true;
      CalculateButton.SetFocus;
    end;  // end of FileOpenDialog.Execute
    ThresOption:=0;
    InitializeRecords;
    MaxR:=4.0;
    MaxH:=2.0;
    QueryPerformanceCounter(c2);
    timeelapsed2:=(c2-c1)/f;
    CifTime.Caption:= 'Time elapsed: '+FF('0.000',timeelapsed2)+' s';
end;

procedure THoppe.AboutButtonClick(Sender: TObject);
begin
  AboutDialog.show;
end;

procedure THoppe.Bonds1Click(Sender: TObject);
var
  Details:boolean;
  c1,c2,f:Int64;

begin
  QueryPerformanceFrequency(f);
  QueryPerformanceCounter(c1);
  if PolGeomButton.Caption='Charge distribution' then
    begin
      PolGeomButton.Caption:='Coordination geometry';
      ShowXCenteredButton.Enabled:=True;
      Calculate;
    end
  else
    begin
      ShowingPolGeom:=true;
      PolGeomButton.Caption:='Charge distribution';
      Details:=DetailedResults.Checked;
      ShowXCenteredButton.Enabled:=False;
      InitializeFaces;
      if ShowCations then
        begin
          GetVolume(1);
          if TMFaces then
            begin
              ShowingPolGeom:=false;
              PolGeomButton.Caption:='Coordination geometry';
              ShowXCenteredButton.Enabled:=True;
              Exit;
            end;
          GetCentroids(1);
          GetIdealPolyhedra(1);
          GetDihedrals(1);
          QueryPerformanceCounter(c2);
          timeelapsed3:=(c2-c1)/f;
          if Details then
            begin
              LoadResults(5,False,'');
              ListResults(5);
            end
          else
            begin
              LoadResults(6,False,'');
              ListResults(6);
            end;
        end
      else
        begin
          GetVolume(2);
          if TMFaces then
            begin
              ShowingPolGeom:=false;
              PolGeomButton.Caption:='Coordination geometry';
              ShowXCenteredButton.Enabled:=True;
              Exit;
            end;
          GetCentroids(2);
          GetIdealPolyhedra(2);
          GetDihedrals(2);
          QueryPerformanceCounter(c2);
          timeelapsed3:=(c2-c1)/f;
          if Details then
            begin
              LoadResults(7,False,'');
              ListResults(7);
            end
          else
            begin
              LoadResults(8,False,'');
              ListResults(8);
            end;
        end;
    end;

end;

procedure THoppe.BondsButtonClick(Sender: TObject);
begin
 GetDistances(True);
 if not GotMaxLengths then
   GetMaxBondLengths;
 BondsDialog:=TBondsDialog.Create(Self);
 if BondsDialog.ShowModal=500 then
   begin
     CalculateButton.Enabled:=true;
     if EXZeroW then OmitCheckBox.Checked:=False
     else OmitCheckBox.Checked:=True;
   end;
end;

procedure THoppe.AutosaveCheckClick(Sender: TObject);
begin
  if not AutosaveCheck.checked and Calculated then
   SaveAsButton.Enabled:=true
  else SaveAsButton.Enabled:=false;
  CalculateButton.Enabled:=true;
end;

procedure THoppe.CalculateButtonClick(Sender: TObject);
begin
  Calculate;
end;

procedure THoppe.QuitButtonClick(Sender: TObject);
begin
  Close;
end;

procedure THoppe.SaveAsButtonClick(Sender: TObject);
var
 s,p:string;

const
 F1='ECoN21 detailed CD-BVS results (*.out)|*.out';
 F2='ECoN21 summary CD-BVS results (*.out)|*.out|'+
    'CSV summary results (*.csv)|*.csv';
 F3='ECoN21 detailed polyhedron geometry (*.pol)|*.pol';
 F4='ECoN21 summary polyhedron geometry (*.pol)|*.pol|'+
    'CSV summary results (*.csv)|*.csv';
begin
  p:=title;
  with SaveDialog1 do
    begin
      case CurrentResults of
      1: begin
           s:=p+'-CC-D.out';
           Filter:=F1;
           FilterIndex:=1;
         end;
      2: begin
           s:=p+'-CC-S.csv';
           Filter:=F2;
           FilterIndex:=3;
         end;
      3: begin
           s:=p+'-AC-D.out';
           Filter:=F1;
           FilterIndex:=1;
         end;
      4: begin
           s:=p+'-AC-S.csv';
           Filter:=F2;
           FilterIndex:=3;
         end;
      5: begin
           s:=p+'-CC-DP.pol';
           Filter:=F3;
           FilterIndex:=1;
         end;
      6: begin
           s:=p+'-CC-SP.csv';
           Filter:=F4;
           FilterIndex:=3;
         end;
      7: begin
           s:=p+'-AC-DP.pol';
           Filter:=F3;
           FilterIndex:=1;
         end;
      8: begin
           s:=p+'-AC-SP.csv';
           Filter:=F4;
           FilterIndex:=3;
         end;
      end;
      FileName:=s;
      if Execute then
        case CurrentResults of
        1: Memo1.Lines.SaveToFile(FileName,TEncoding.UTF8);
        2: if FilterIndex=1 then Memo1.Lines.SaveToFile(FileName,TEncoding.UTF8)
           else SaveCSV(1,FileName);
        3: Memo1.Lines.SaveToFile(FileName,TEncoding.UTF8);
        4: if FilterIndex=1 then Memo1.Lines.SaveToFile(FileName,TEncoding.UTF8)
           else SaveCSV(2,FileName);
        5: Memo1.Lines.SaveToFile(FileName,TEncoding.UTF8);
        6: if FilterIndex=1 then Memo1.Lines.SaveToFile(FileName,TEncoding.UTF8)
           else SavePolGeomCSV(1,FileName);
        7: Memo1.Lines.SaveToFile(FileName,TEncoding.UTF8);
        8: if FilterIndex=1 then Memo1.Lines.SaveToFile(FileName,TEncoding.UTF8)
           else SavePolGeomCSV(2,FileName);
        end;
    end;
end;

procedure THoppe.ChardiIterationClick(Sender: TObject);
begin
   if Title<>'' then CalculateButton.Enabled:=true;
end;

procedure THoppe.ShowXCenteredButtonClick(Sender: TObject);
begin
  PolGeomButton.Caption:='Coordination geometry';
  if ShowXCenteredButton.Caption='>> Anion-centered' then
    begin
      ShowCations:=false;
      ShowXCenteredButton.Caption:='>> Cation-centered';
    end
  else
    begin
      ShowCations:=True;
      ShowXcenteredButton.Caption:='>> Anion-centered';
    end;
  Calculate;
end;

procedure THoppe.SectionCom(Sender: TObject);
begin
  if Calculated then
    begin
      if not ShowingPolGeom  then
        begin
          if ShowCations then
            begin
              if DetailedResults.checked then
                begin
                  LoadResults(1,False,'');
                  ListResults(1);
                end
             else
                begin
                  LoadResults(2,False,'');
                  ListResults(2);
                end;
            end
          else
            begin
              if DetailedResults.checked then
                begin
                  LoadResults(3,False,'');
                  ListResults(3);
                end
              else
                begin
                  LoadResults(4,False,'');
                  ListResults(4);
                end;
            end
        end
      else
        begin
          if ShowCations then
            begin
              if DetailedResults.checked then
                begin
                  LoadResults(5,False,'');
                  ListResults(5);
                end
             else
                begin
                  LoadResults(6,False,'');
                  ListResults(6);
                end;
            end
          else
            begin
              if DetailedResults.checked then
                begin
                  LoadResults(7,False,'');
                  ListResults(7);
                end
              else
                begin
                  LoadResults(8,False,'');
                  ListResults(8);
                end;
            end
        end;
    end;
  if not SHowingPolGeom then
    begin
      if (Hoppe.DetailedResults.Checked) then
        begin
          SectionCombo.Enabled:=true;
          SectionComboLabel.Enabled:=true;
        end;
    end;
end;


procedure THoppe.FormShow(Sender: TObject);

begin
  CLine:=0;
  DetailedResults.Checked:=false;
  WindowState:=wsMaximized;
  with SG2 do
    begin
      Cells[0,0]:='No.';
      Cells[1,0]:='Label';
      Cells[2,0]:='Site population';
      Cells[3,0]:='Oxidation nr.';
      Cells[4,0]:='Multiplicity';
      Cells[5,0]:='X';
      Cells[6,0]:='Y';
      Cells[7,0]:='Z';
      Cells[8,0]:='Occupancy';
      Cells[9,0]:='Ro';
      Cells[11,0]:='Symbol';
      ColWidths[0]:=35;
      ColWidths[1]:=123;
      ColWidths[2]:=160;
      ColWidths[3]:=74;
      ColWidths[4]:=70;
      ColWidths[5]:=75;
      ColWidths[6]:=75;
      ColWidths[7]:=75;
      ColWidths[8]:=68;
      ColWidths[9]:=1;
      ColWidths[10]:=1;
      ColWidths[11]:=1;
      FixedColor:=clBtnFace;
    end;
    ShowCations:=true;
    ThresOption:=0;
    EndItOption:=1;
    ExZeroW:=false;
    NearestLimit:=false;
    MinDih:=170;
    MaxSDist:=0.8;
    Threshold:=0.005;
    MAPDImprovement:=1.0;
    NonIT:=False;
    ChardiIT:=False;
end;

procedure THoppe.MaxRadiusChange(Sender: TObject);
begin
   RadModified:=true;
   if Title<>'' then CalculateButton.Enabled:=true;
end;

procedure THoppe.NoniterativeClick(Sender: TObject);
begin
  ITModified:=true;
  if Title<>'' then CalculateButton.Enabled:=true;
end;

procedure THoppe.SectionComboSelect(Sender: TObject);
var
  Section:string;
  p,l,i,VisLines:integer;

begin
  VisLines:=LinesVisible(Memo1);
  Section:=Copy(SectionCombo.Text,7,Length(SectionCombo.Text));
  for i:=0 to Memo1.Lines.Count-1 do
    if pos(Section,Memo1.Lines[i])>0 then
      begin
        l:=SendMessage(Memo1.Handle,EM_LINEFROMCHAR,p-1,0);
        Memo1.SelStart:=Memo1.Perform(EM_LINEINDEX, i, 0);
        Memo1.SelLength:=Length(Memo1.Lines[i]);
        Memo1.SetFocus;
        if (i>l+VisLines) then
         begin
          SendMessage(Memo1.Handle, WM_VSCROLL, SB_PAGEDOWN, 0);
          SendMessage(Memo1.Handle, WM_VSCROLL, SB_LINEUP, 0);
         end;
        SendMessage(Memo1.Handle, WM_HSCROLL, SB_PAGELEFT, 0);
        Break;
      end;
end;

procedure THoppe.SG2DblClick(Sender: TObject);
begin
 with SG2 do
   begin
     ColWidths[0]:=35;
     ColWidths[1]:=123;
     ColWidths[2]:=160;
     ColWidths[3]:=74;
     ColWidths[4]:=70;
     ColWidths[5]:=75;
     ColWidths[6]:=75;
     ColWidths[7]:=75;
     ColWidths[8]:=68;
     ColWidths[9]:=1;
     ColWidths[10]:=1;
     ColWidths[11]:=1;
   end;
end;

procedure THoppe.SG2DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
  State: TGridDrawState);
var
  S: string;
  SavedAlign: word;
begin
  with SG2.Canvas do
    begin
      if ARow=0 then
        begin
          Font.Name:='Tahoma';
          Font.Size:=8;
          if gdSelected in State then
            begin  // selected cell
              Brush.Color:=clHighLight;
              Font.Color:=clHighLightText;
            end
          else
            if gdFixed in State then
              begin  // fixed cell
                Brush.Color:=clBtnFace;
                Font.Color:=clWindowText;
              end
            else
              begin
                Brush.Color:=clWindow;  // normal cell
                Font.Color:=clWindowText;
              end;
           FillRect(Rect);
           S:=SG2.Cells[ACol,ARow]; // cell contents
           SavedAlign:=SetTextAlign(Handle,TA_CENTER);
           TextRect(Rect,Rect.Left+(Rect.Right-Rect.Left) div 2,Rect.Top+2,S);
           SetTextAlign(Handle,SavedAlign);
           SG2.FixedRows:=1;
        end;
    end;
end;

end.